package org.bioconductor.packages.rservices;

import junit.framework.JUnit4TestAdapter;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

public class RJFileReferencesTest extends TypeTestUtil {
	/**
	 * Used for backward compatibility (IDEs, Ant and JUnit 3.x text runner)
	 */
	public static junit.framework.Test suite() {
		return new JUnit4TestAdapter(RJFileReferencesTest.class);
	}

	/**
	 * Sets up the test fixture; Called before all the tests; Called only once.
	 */
	@BeforeClass
	public static void loadCLevelConverter() throws Exception {
		e.voidEval("regAddonCvt2()");
	}

	@Test
	public void testLocalRJFileReferences() throws Exception {
		RJFileReferences refs = new RJFileReferences(
				new String[] { "foo/bar" }, new String[] { "baz" },
				new String[] { "TYPE" });
		assertTrue(refs.equals(refs));
	}

	@Test
	public void testEmptyRJFileReferencesFromR() throws Exception {
		Object res = e.eval("FileReferences()");
		RJFileReferences refs = new RJFileReferences();
		assertTrue(refs.equals(res));
	}

	@Test
	public void testEmptyRJFileReferences() throws Exception {
		RJFileReferences refs = new RJFileReferences();
		Object res = reflectObj(refs);
		assertTrue(refs.equals(res));
	}

	@Test
	public void testRJFileReferences() throws Exception {
		String[] urls = new String[] { "/foo/bar", "/foo/baz" };
		String[] names = new String[] { "bar", "baz" };
		String[] types = new String[] { "TYPE1", "TYPE2" };
		RJFileReferences refs = new RJFileReferences(urls, names, types);
		Object res = reflectObj(refs);
		assertTrue(refs.equals(res));
	}
}
