\name{Test utilities}
\alias{checkJava2R}
\alias{checkPkgVersion}
\alias{reflectObj}

\title{Utilities for facilitating data and method tests}
\description{
  These functions provide utilities that are useful when testing
  different aspects of R / Java communication.
}
\usage{
checkJava2R(javaData, rVariable)
checkPkgVersion(pkgName, expVersion)
reflectObj(x, verbose=FALSE)
}
\arguments{
  \item{javaData}{Object translated from Java}
  \item{rVariable}{R variable containing an instance that is supposed to
	be identical to \code{javaData}. \code{rVariable} might have been
	created in previous calls, or loaded from a data file.}
  \item{pkgName}{Name of package whose version will be determined.}
  \item{expVersion}{Character string with expected package version.}
  \item{x}{Object to be returned to Java.}
  \item{verbose}{Logical, indicating whether R reports information about
	the object.}
}
\value{
  \code{checkJava2R} returns \code{TRUE} if \code{javaData} is identical
  to \code{rVariable}, or signals an error otherwise.

  \code{checkPkgVersion} returns true if the installed package matches
  the expected package, or signals a warning otherwise.

  \code{reflectObj} returns the object.
}
\author{Nianhua Li}
\keyword{programming}
